<?php

namespace Drupal\restrict_ip_email_domains\Mapper;

use Drupal\restrict_ip\Mapper\RestrictIpMapper;

/**
 * Decorates the RestrictIpMapper service.
 *
 * @package Drupal\restrict_ip_email_domains\Mapper
 */
class RestrictIpEdMapperDecorator extends RestrictIpMapper {

  /**
   * {@inheritdoc}
   */
  public function getRestrictedEmailDomains() {
    $query = $this->connection->select('restrict_ip_email_domains', 'ed');
    $query->fields('ed', ['email_domain']);
    return $query->execute()->fetchCol();
  }

  /**
   * {@inheritdoc}
   */
  public function saveRestrictedEmailDomains(array $email_domains, $overwriteExisting = TRUE) {
    if ($overwriteExisting) {
      $this->connection->delete('restrict_ip_email_domains')->execute();
    }

    $query = $this->connection->insert('restrict_ip_email_domains')->fields(['email_domain']);
    foreach ($email_domains as $email_domain) {
      $query->values(['email_domain' => $email_domain]);
    }

    $query->execute();
  }

}
